<?php
/**  * event_edit.php */

define('SM_PATH','../../');

/* Calender plugin required files. */
require_once(SM_PATH . 'plugins/calendar/calendar_data.php');
require_once(SM_PATH . 'plugins/calendar/functions.php');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/html.php');

/* get globals */
unset($global_val_list) ;
$global_val_list = array('year',  'month',  'day',  'hour', 'minute') ;
foreach($global_val_list as $global_val_name){
  if    (isset($_GET[$global_val_name]))  { $$global_val_name = $_GET[$global_val_name];  }
  elseif(isset($_POST[$global_val_name])) { $$global_val_name = $_POST[$global_val_name]; }
}
unset($global_val_list) ;
$global_val_list =
  array( 'event_year', 'event_month', 'event_day',  'event_hour', 'event_minute',
         'event_length', 'event_priority', 'event_title', 'event_text',
         'send',         'confirmed' ,       'updated'
       ) ;
foreach($global_val_list as $global_val_name){
  if (isset($_POST[$global_val_name])) { $$global_val_name = $_POST[$global_val_name]; }
}
unset($global_val_list) ;
/* got 'em */

$event_title = htmlspecialchars( $event_title, ENT_QUOTES );
$event_text = htmlspecialchars( $event_text, ENT_QUOTES );


//  <!--  update event info  -->
function show_event_form() {
  global $color, $editor_size, $year, $day, $month, $hour, $minute, $calendardata;

  $tmparray = $calendardata["$month$day$year"]["$hour$minute"];
  $tmparray[message] = str_replace("<br />" , "\n" , $tmparray[message] ) ;

  echo
    "\n<FORM name=eventupdate action=\"event_edit.php\" METHOD=POST >\n".
    "      <INPUT TYPE=hidden NAME=\"year\" VALUE=\"$year\">\n".
    "      <INPUT TYPE=hidden NAME=\"month\" VALUE=\"$month\">\n".
    "      <INPUT TYPE=hidden NAME=\"day\" VALUE=\"$day\">\n".
    "      <INPUT TYPE=hidden NAME=\"hour\" VALUE=\"$hour\">\n".
    "      <INPUT TYPE=hidden NAME=\"minute\" VALUE=\"$minute\">\n".

    "      <INPUT TYPE=HIDDEN NAME=\"event_year\" VALUE=\"$year\">\n".
    "      <INPUT TYPE=HIDDEN NAME=\"event_month\" VALUE=\"$month\">\n".
    "      <INPUT TYPE=HIDDEN NAME=\"event_day\" VALUE=\"$day\">\n".
    "      <INPUT TYPE=HIDDEN NAME=\"event_hour\" VALUE=\"$hour\">\n".
    "      <INPUT TYPE=HIDDEN NAME=\"event_minute\" VALUE=\"$minute\">\n".

    "      <INPUT TYPE=hidden NAME=\"updated\" VALUE=\"yes\">\n".

    html_tag( 'tr' ) .
      html_tag( 'td', _("Date:"), 'right', $color[4] ) . "\n" .
      html_tag( 'td', '', 'left', $color[4] ) .
         "      <SELECT NAME=\"event_year\">\n";
                    select_option_year($year);
    echo "      </SELECT>\n" .
         "      &nbsp;&nbsp;\n" .
         "      <SELECT NAME=\"event_month\">\n";
                    select_option_month($month);
    echo "      </SELECT>\n".
         "      &nbsp;&nbsp;\n".
         "      <SELECT NAME=\"event_day\">\n";
                    select_option_day($day);
    echo "      </SELECT>\n".
         "      </td></tr>\n".
    html_tag( 'tr' ) .
      html_tag( 'td', _("Time:"), 'right', $color[4] ) . "\n" .
      html_tag( 'td', '', 'left', $color[4] ) .
         "      <SELECT NAME=\"event_hour\">\n";
                    select_option_hour($hour);
    echo "      </SELECT>\n".
         "      &nbsp;:&nbsp;\n".
         "      <SELECT NAME=\"event_minute\">\n";
                    select_option_minute($minute);
    echo "      </SELECT>\n".
         "      </td></tr>\n".
    html_tag( 'tr' ) .
      html_tag( 'td', _("Length:"), 'right', $color[4] ) . "\n" .
      html_tag( 'td', '', 'left', $color[4] ) .
         "      <SELECT NAME=\"event_length\">\n";
                    select_option_length($tmparray['length']);
    echo "      </SELECT>\n".
         "      </td></tr>\n".
    html_tag( 'tr' ) .
      html_tag( 'td', _("Priority:"), 'right', $color[4] ) . "\n" .
      html_tag( 'td', '', 'left', $color[4] ) .
         "      <SELECT NAME=\"event_priority\">\n";
                    select_option_priority($tmparray['priority']);
    echo "      </SELECT>\n".
         "      </td></tr>\n".
    html_tag( 'tr' ) .
      html_tag( 'td', _("Title:"), 'right', $color[4] ) . "\n" .
      html_tag( 'td', '', 'left', $color[4] ) .
         "      <INPUT TYPE=text NAME=\"event_title\" VALUE=\"" . $tmparray[title] .
                       "\" SIZE=30 MAXLENGTH=50><BR>\n".
         "      </td></tr>\n".
      html_tag( 'td',
         "      <TEXTAREA NAME=\"event_text\" ROWS=5 COLS=\"" . $editor_size .
                "\" WRAP=SOFT>$tmparray[message]</TEXTAREA>\n" ,
      'left', $color[4], 'colspan="2"' ) .
      '</tr>' . html_tag( 'tr' ) .
      html_tag( 'td',
               "<INPUT TYPE=SUBMIT NAME=send VALUE=\"" .
               _("Update Event") . "\">\n" ,
         'left', $color[4], 'colspan="2"' ) .
      "</tr></FORM>\n";
}

//  <!--  self explenatory  -->
function confirm_update() {
  global $calself, $year, $month, $day, $hour, $minute, $calendardata, $overdata,
         $color, $event_year, $event_month, $event_day, $event_hour, $event_minute,
         $event_length, $event_priority, $event_title, $event_text;

  $over_flug = 0 ; $over_str = "&nbsp;" ; $over_yes = _("Yes") ;
  $tmparray = $calendardata["$month$day$year"]["$hour$minute"];
  $overarray = $overdata["$event_month$event_day$event_year"]["$event_hour$event_minute"];

  if ( is_array($overarray) ) {
    $over_flug = 1 ;
    $over_str = "ʣ٥" ;
    $over_yes = _("񤭰ư") ;
  }
    $confirm_yes = 
            "    <FORM NAME=\"updateevent\" METHOD=POST ACTION=\"$calself\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"year\"           VALUE=\"$year\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"month\"          VALUE=\"$month\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"day\"            VALUE=\"$day\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"hour\"           VALUE=\"$hour\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"minute\"         VALUE=\"$minute\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_year\"     VALUE=\"$event_year\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_month\"    VALUE=\"$event_month\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_day\"      VALUE=\"$event_day\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_hour\"     VALUE=\"$event_hour\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_minute\"   VALUE=\"$event_minute\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_priority\" VALUE=\"$event_priority\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_length\"   VALUE=\"$event_length\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_title\"    VALUE=\"$event_title\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_text\"     VALUE=\"$event_text\">\n".
            "       <INPUT TYPE=hidden NAME=\"updated\"        VALUE=\"yes\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"confirmed\"      VALUE=\"yes\">\n".
            '       <INPUT TYPE=SUBMIT VALUE="' . $over_yes . "\">\n".
            "    </FORM>\n" ;
    $confirm_no =
            "    <FORM NAME=\"updateevent\" METHOD=POST ACTION=\"$calself\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"year\"           VALUE=\"$year\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"month\"          VALUE=\"$month\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"day\"            VALUE=\"$day\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"hour\"           VALUE=\"$hour\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"minute\"         VALUE=\"$minute\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_year\"     VALUE=\"$event_year\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_month\"    VALUE=\"$event_month\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_day\"      VALUE=\"$event_day\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_hour\"     VALUE=\"$event_hour\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_minute\"   VALUE=\"$event_minute\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_priority\" VALUE=\"$event_priority\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_length\"   VALUE=\"$event_length\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_title\"    VALUE=\"$event_title\">\n".
            "       <INPUT TYPE=HIDDEN NAME=\"event_text\"     VALUE=\"$event_text\">\n".
            '       <INPUT TYPE=SUBMIT VALUE="' . _("Խ") . "\">\n".
            "    </FORM>\n" ;
  echo
    html_tag( 'table',
      html_tag( 'tr',
        html_tag( 'th', _("Do you really want to change this event from:") .
                       "<br>\n", '', $color[4], 'colspan="3"' ) ."\n"  ) .
          html_tag( 'tr',
            html_tag( 'td', _("Date:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', $year.'ǯ'.$month.''.$day.'' ,
                      'left', $color[4], 'colspan="2"' ) ."\n"        ) .
          html_tag( 'tr',
            html_tag( 'td', _("Time:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', $hour.':'.$minute ,
                      'left', $color[4], 'colspan="2"' ) ."\n"        ) .
          html_tag( 'tr',
            html_tag( 'td', _("Priority:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', 
                      ( ($tmparray[priority]=="0") ? _("Normal") : _("High") ) ,
                      'left', $color[4], 'colspan="2"' ) ."\n"        ) .
          html_tag( 'tr',
            html_tag( 'td', _("Title:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', $tmparray[title] ,
                      'left', $color[4], 'colspan="2"' ) ."\n"        ) .
          html_tag( 'tr',
            html_tag( 'td', _("Message:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', nl2br($tmparray[message]) ,
                      'left', $color[4], 'colspan="2"' ) ."\n"        ) .

          html_tag( 'tr',
            html_tag( 'th', _("to:") . "<br>\n", '', $color[4], 'colspan="2"' ) ."\n"  .
                html_tag( 'td', $over_str , 'center', $color[4] ) ."\n"
            ) .

          html_tag( 'tr',
            html_tag( 'td', _("Date:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', $event_year.'ǯ'.$event_month.''.$event_day.'',
                      'left', $color[4] ) . "\n" .
            html_tag( 'td', 
             ( ($over_flug==1) ? $event_year."ǯ".$event_month."".$event_day."" : "&nbsp;" )
                      , 'left', $color[4] ) . "\n"
          ) .
          html_tag( 'tr',
            html_tag( 'td', _("Time:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', $event_hour.':'.$event_minute , 'left', $color[4] ) ."\n".
            html_tag( 'td', 
             ( ($over_flug==1) ? $event_hour.":".$event_minute : "&nbsp;" )
                      , 'left', $color[4] ) . "\n"
          ) .
          html_tag( 'tr',
            html_tag( 'td', _("Priority:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', 
                       ( ($event_priority=="0") ? _("Normal") : _("High") ) ,
                      'left', $color[4] ) ."\n".
            html_tag( 'td', 
                       ( ($over_flug==1) ?
                            ( ($overarray[priority]=="0") ? _("Normal") : _("High") )
                       : "&nbsp;" )
             , 'left', $color[4] ) ."\n"
          ) .
          html_tag( 'tr',
            html_tag( 'td', _("Title:") , 'right', $color[4] ) ."\n"  .
            html_tag( 'td', $event_title , 'left', $color[4] ) ."\n"  .
            html_tag( 'td', 
                      ( ($over_flug==1) ? $overarray[title] : "&nbsp;" )
                      , 'left', $color[4] ) ."\n"
          ) .
          html_tag( 'tr',
            html_tag( 'td', _("Message:") , 'right', $color[4] ) ."\n" .
            html_tag( 'td', nl2br($event_text) , 'left', $color[4] ) ."\n" .
            html_tag( 'td',
                      ( ($over_flug==1) ? nl2br($overarray[message]) : "&nbsp;" )
                     , 'left', $color[4] ) ."\n"
          ) .

          html_tag( 'tr',
            html_tag( 'td', "&nbsp;"     , 'right', $color[4] ) ."\n" .
            html_tag( 'td', $confirm_yes , 'left', $color[4]  ) ."\n" .
            html_tag( 'td', $confirm_no  , 'left', $color[4]  ) ."\n"

      ) ,
    '', $color[0], 'border="0" cellpadding="2" cellspacing="1"' );
}

if ($month <= 0) { $month = date( 'm' ); }
if ($year  <= 0) { $year  = date( 'Y' ); }
if ($day   <= 0) { $day   = date( 'd' ); }
if ($hour  <= 0) { $hour  = '08';        }

$calself=basename($PHP_SELF);

displayPageHeader($color, 'None');

// <!--  load calendar menu  -->
calendar_header();

echo
  html_tag( 'tr', '', '', $color[0] ) .
    html_tag( 'td', '', 'left' ) .
      html_tag( 'table', '', '', $color[0],
                'width="100%" border="0" cellpadding="2" cellspacing="1"' ) .
        html_tag( 'tr' ) .
          html_tag( 'td',
                     date_intl( _("l, F j Y"), mktime(0, 0, 0, $month, $day, $year)) ,
          'left', '', 'colspan="2"' );

if (!isset($updated)){
    //  <!--  get changes to event -->
    $calendardata = readcalendardataGetOne($year , $month , $day , "$hour$minute") ;
    show_event_form();
} else {
    if (!isset($confirmed)){
        // <!--  confirm changes  -->
        $calendardata = readcalendardataGetOne($year , $month , $day , "$hour$minute") ;
        if ( $year!=$event_year || $month!=$event_month || $day!=$event_day ||
             $hour!=$event_hour || $minute!=$event_minute )  {
                $overdata = readcalendardataGetOne
                    ($event_year, $event_month, $event_day, "$event_hour$event_minute") ;
        }
        confirm_update();
    } else {
        // <!--  Changes event data & UpDate -->
        echo 
          html_tag( 'tr',
            html_tag( 'td', _("Event updated!"), 'left' )
          ) . "\n";
        echo 
          html_tag( 'tr',
            html_tag( 'td',
                      "<a href=\"day.php?year=$year&amp;month=$month&amp;day=$day\">" . 
                       _("Day View") ."</a>",
            'left' )
          ) . "\n";
        // $fixdate = date( 'mdY', mktime(0, 0, 0, $event_month, $event_day, $event_year));
        // <!--  if event has been moved to different year then act accordingly   -->
        			//  if ($year!=$event_year)  $year=$event_year;
        delete_event( $year, $month, $day , $hour.$minute ) ;
        writecalendardata3(
             $event_year ,  $event_month  ,  $event_day ,   $event_hour.$event_minute     , 
             array( 'length'   => $event_length,    'priority' => $event_priority,
                    'title'    => $event_title,     'message'  => $event_text,
                    'reminder' => ''
                  )
        ) ;
    }
}

?>
</table></td></tr></table>
</body></html>
