<?php
/*    calendar_data.php   */

// this is array that contains all events
// it is three dimensional array with fallowing structure
// $calendardata[date][time] = array(length,priority,title,message);

$calendardata = array();

/************************************************
 * Users Database 1 :
 * ---------
 * The sqcalender user's table should have some columns:

CREATE TABLE "sq_scheduler" (
 "username"   varchar(128) NOT NULL,   -- 桼̾
 "utime"      int          NOT NULL,   -- Ͽ maketime
 "year"       varchar(6)   NOT NULL,   -- ٥ǯ   date('Y')
 "month"      varchar(3)   NOT NULL,   -- ٥ȷ   date('m')
 "day"        varchar(3)   NOT NULL,   -- ٥   date('d')
 "stime"      varchar(5)   NOT NULL,   -- ٥ date('Hi')
 "length"     varchar(5)           ,   -- ٥Ĺ ( 0360 )
 "priority"   varchar(2)           ,   --        ( 0,1 )
 "alram"      int   DEFAULT 0      ,   -- 顼 maketime
 "rtime"      int   DEFAULT 0      ,   -- remind   maketime
 "rmail"      text        ,            -- remind mail address(4Ĥޤ)
 "title"      text        ,            -- ȥ
 "message"    text        ,            -- åʸ
 "grpmladmin" text                     -- MLɥ쥹(ʣ)
                                       --   (MLʡΤͭ)
);
CREATE INDEX "sq_scheduler_index_key" ON "sq_scheduler"
  ( "username" , "year" , "month" , "day" ,  "utime" , "title" ) ;


 Use DB handler PEAR-DB class  require_once('DB.php');
 Thease Global Valiables :
    $sqcalender_dsn
    $sqcalender_table
 you use DataBase DSN and Table name.

************************************************/

require_once('DB.php');
$sqcalender_dsn = 'pgsql://squirreluser:sqpassword@localhost/squirrelmail' ;
$sqcalender_table = 'sq_scheduler' ;
$sq_global_calendar_user  = 'global' ;

//  <!--Search Same Title by username form $year $month $day-->
function searchtitle( $title , $stime , $delyear , $delmonth ,$delday) {
  global $username , $sqcalender_dsn , $sqcalender_table ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh);  return false; }

  $query = sprintf(
     "SELECT year,  month, day,   stime,   length,   priority ,
             alram, rtime, rmail, title  , message,  grpmladmin , serial
        FROM %s
       WHERE username='%s' AND title='%s' AND stime='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($username), $dbh->quoteString($title), $dbh->quoteString($stime)
    ) ;
  $tmpdata = $dbh->getAll($query);
  foreach($tmpdata as $fdata ){
    $fooyear  = $fdata[0];   $foomonth = $fdata[1];
    $fooday   = $fdata[2];   $foommddyy = $foomonth.$fooday.$fooyear ;
    $fooutime = mktime(0,0,0,$foomonth,$fooday,$fooyear) ;
    $endutime = mktime(0,0,0,$delmonth,$delday,$delyear) ;
    if ( $fooutime <= $endutime ) {
      $calendardata[$foommddyy][$fdata[3]] = 
      array( 'length'   => $fdata[4],   'priority' => $fdata[5],
             'title'    => htmlspecialchars($fdata[9],ENT_NOQUOTES),
             'message'  => htmlspecialchars($fdata[10],ENT_NOQUOTES),
      ) ;
    }
  }
  return $calendardata ;
}


//  <!--Read Global Calender Data a month-->
function read_global_calendar_data($year , $month) {
  global $sqcalender_dsn , $sqcalender_table, $sq_global_calendar_user ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh);   return false;   }
  $query = sprintf(
     "SELECT year,  month, day,   stime,   length,   priority ,
             alram, rtime, rmail, title  , message,  grpmladmin , serial
        FROM %s
       WHERE username='%s' AND year='%s' AND month='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($sq_global_calendar_user)   ,
       $dbh->quoteString($year), $dbh->quoteString($month)
    ) ;
  $tmpdata = $dbh->getAll($query);
  foreach($tmpdata as $fdata ){
    $fooyear  = $fdata[0];   $foomonth = $fdata[1];
    $fooday   = $fdata[2];   $foommddyy = $foomonth.$fooday.$fooyear ;
      $calendardata[$foommddyy][$fdata[3]] = 
      array( 'length'   => $fdata[4],   'priority' => $fdata[5],
             'title'    => htmlspecialchars($fdata[9],ENT_NOQUOTES),
             'message'  => htmlspecialchars($fdata[10],ENT_NOQUOTES),
      ) ;
  }
  return $calendardata ;
}


//  <!--Read Calender Data a month-->
function readcalendardata($year , $month) {
  global $username , $sqcalender_dsn , $sqcalender_table ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh); return false; }

  $query = sprintf(
     "SELECT year,  month, day,   stime,   length,   priority ,
             alram, rtime, rmail, title  , message,  grpmladmin , serial
        FROM %s
       WHERE username='%s' AND year='%s' AND month='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($username)   ,
       $dbh->quoteString($year), $dbh->quoteString($month)
    ) ;
  $tmpdata = $dbh->getAll($query);
  foreach($tmpdata as $fdata ){
    $fooyear  = $fdata[0];   $foomonth = $fdata[1];
    $fooday   = $fdata[2];   $foommddyy = $foomonth.$fooday.$fooyear ;
      $calendardata[$foommddyy][$fdata[3]] = 
      array( 'length'   => $fdata[4],   'priority' => $fdata[5],
             'title'    => htmlspecialchars($fdata[9],ENT_NOQUOTES),
             'message'  => htmlspecialchars($fdata[10],ENT_NOQUOTES),
      ) ;
  }
  return $calendardata ;
}


//  <!--Read Global Calender Data a day-->
function read_global_calendar_data_day ($year , $month , $day) {
  global $sqcalender_dsn , $sqcalender_table, $sq_global_calendar_user ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh); return false; }
  $query = sprintf(
     "SELECT year,  month, day,   stime,   length,   priority ,
             alram, rtime, rmail, title  , message,  grpmladmin , serial
        FROM %s
       WHERE username='%s' AND year='%s' AND month='%s' AND day='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($sq_global_calendar_user) ,
       $dbh->quoteString($year), $dbh->quoteString($month),
       $dbh->quoteString($day)
    ) ;
  $tmpdata = $dbh->getAll($query);
  foreach($tmpdata as $fdata ){
    $fooyear  = $fdata[0];   $foomonth = $fdata[1];
    $fooday   = $fdata[2];   $foommddyy = $foomonth.$fooday.$fooyear ;
      $calendardata[$foommddyy][$fdata[3]] = 
      array( 'length'   => $fdata[4],   'priority' => $fdata[5],
             'title'    => htmlspecialchars($fdata[9],ENT_NOQUOTES),
             'message'  => htmlspecialchars($fdata[10],ENT_NOQUOTES),
      ) ;
  }
  return $calendardata ;
}


// <!-- Read Calender Data a day-->
function readcalendardataday($year , $month , $day) {
  global $username , $sqcalender_dsn , $sqcalender_table ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh); return false;  }
  $query = sprintf(
     "SELECT year,  month, day,   stime,   length,   priority ,
             alram, rtime, rmail, title  , message,  grpmladmin , serial
        FROM %s
       WHERE username='%s' AND year='%s' AND month='%s' AND day='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($username) ,
       $dbh->quoteString($year), $dbh->quoteString($month),
       $dbh->quoteString($day)
    ) ;
  $tmpdata = $dbh->getAll($query);
  foreach($tmpdata as $fdata ){
    $fooyear  = $fdata[0];   $foomonth = $fdata[1];
    $fooday   = $fdata[2];   $foommddyy = $foomonth.$fooday.$fooyear ;
      $calendardata[$foommddyy][$fdata[3]] = 
      array( 'length'   => $fdata[4],   'priority' => $fdata[5],
             'title'    => htmlspecialchars($fdata[9],ENT_NOQUOTES),
             'message'  => htmlspecialchars($fdata[10],ENT_NOQUOTES),
      ) ;
  }
  return $calendardata ;
}


//  <!--Read Calender Data Get One Event-->
function readcalendardataGetOne($year , $month , $day ,$stime) {
  global $username , $sqcalender_dsn , $sqcalender_table ;
  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh);  return false;  }

  $query = sprintf(
     "SELECT year,  month, day,   stime,   length,   priority ,
             alram, rtime, rmail, title  , message,  grpmladmin , serial
        FROM %s
       WHERE username='%s' AND year='%s' AND month='%s' AND day='%s' AND stime='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($username) ,
       $dbh->quoteString($year), $dbh->quoteString($month),
       $dbh->quoteString($day),  $dbh->quoteString($stime)
    ) ;
  $fdata = $dbh->getRow($query);
    $fooyear  = $fdata[0];   $foomonth = $fdata[1];
    $fooday   = $fdata[2];   $foommddyy = $foomonth.$fooday.$fooyear ;
      $calendardata[$foommddyy][$fdata[3]] = 
      array( 'length'   => $fdata[4],   'priority' => $fdata[5],
             'title'    => htmlspecialchars($fdata[9],ENT_NOQUOTES),
             'message'  => htmlspecialchars($fdata[10],ENT_NOQUOTES),
      ) ;
  return $calendardata ;
}

// <!--Calnrar Data Insert & UpDate-->
function writecalendardata3( $year, $month, $day, $stime ,$calbar ) {
  global $username , $sqcalender_dsn , $sqcalender_table ;

  $alram = $rtime = 0 ;    $rmail = $grpmladmin = "" ;
  $calbar['rmail'] = $calbar['$grpmladmin'] = "" ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh); return false; }
  $pre_query = sprintf(
     "SELECT serial
        FROM %s
       WHERE username='%s' AND year='%s' AND month='%s' AND day='%s' AND stime='%s'
       ORDER BY year,month,day,stime  " ,
     $sqcalender_table ,
       $dbh->quoteString($username) ,
       $dbh->quoteString($year), $dbh->quoteString($month),
       $dbh->quoteString($day),  $dbh->quoteString($stime)
    ) ;

  $tmpdata = $dbh->getAll($pre_query);
  if ( count($tmpdata) == 0 ) {
      $query = sprintf(
        "INSERT INTO %s ( username, utime,    year,   month,  day,   stime,
                          length,   priority, alram,  rtime,  rmail, title,
                          message,  grpmladmin )
              VALUES    ( '%s',      %s,      '%s',   '%s',   '%s' , '%s' ,
                          '%s',     '%s',      %s,     %s,    '%s' , '%s' ,
                          '%s',     '%s'    ) " ,
           $sqcalender_table ,
              $dbh->quoteString($username) , time() ,
              $dbh->quoteString($year),   $dbh->quoteString($month),
              $dbh->quoteString($day),    $dbh->quoteString($stime),
              $dbh->quoteString($calbar['length']),  $dbh->quoteString($calbar['priority']),
              $alram , $rtime ,
              $dbh->quoteString($calbar['rmail'])  ,  $dbh->quoteString($calbar['title']),
              $dbh->quoteString($calbar['message']),  $dbh->quoteString($calbar['$grpmladmin'])
       ) ;
  } else {
   unset($tmpdata);
   $serial = $dbh->getOne($pre_query);
     $query = sprintf(
      "UPDATE %s SET               utime=%s,      year='%s',  month='%s', day='%s',   stime='%s',
                     length='%s',  priority='%s', alram=%s,   rtime=%s,   rmail='%s', title='%s',
                     message='%s', grpmladmin='%s'
               WHERE serial=%s " ,
           $sqcalender_table ,
              time() ,
              $dbh->quoteString($year),   $dbh->quoteString($month) ,
              $dbh->quoteString($day),    $dbh->quoteString($stime) ,
              $dbh->quoteString($calbar['length']),  $dbh->quoteString($calbar['priority']),
              $alram , $rtime ,
              $dbh->quoteString($calbar['rmail']) ,   $dbh->quoteString($calbar['title']),
              $dbh->quoteString($calbar['message']),  $dbh->quoteString($calbar['$grpmladmin']) ,
              $serial
      ) ;
  }

  $dbh->simpleQuery("BEGIN TRANSACTION");
  $res = $dbh->simpleQuery($query);
  if (DB::isError($res)) {
    $dbh->simpleQuery("ROLLBACK TRANSACTION");
  }
  $dbh->simpleQuery("COMMIT TRANSACTION");
  return true;
}


//  <!-- deletes event from file-->
function delete_event($delyear, $delmonth, $delday, $delstime) {
  global $username , $sqcalender_dsn , $sqcalender_table ;

  $dbh = DB::connect($sqcalender_dsn,true);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh);   return false;  }
  $dbh->simpleQuery("BEGIN TRANSACTION");

  $query = sprintf(
      "DELETE FROM %s
             WHERE username='%s' AND year='%s'  AND month='%s' AND
                   day='%s'      AND stime='%s' ",
        $sqcalender_table ,
           $dbh->quoteString($username),
           $dbh->quoteString($delyear) , $dbh->quoteString($delmonth),
           $dbh->quoteString($delday)  , $dbh->quoteString($delstime)
    ) ;
  $res = $dbh->simpleQuery($query);
  if (DB::isError($res)) {
     $dbh->simpleQuery("ROLLBACK TRANSACTION");
  }
  $dbh->simpleQuery("COMMIT TRANSACTION");
  return true;
}


?>
