<?php
/**  * week.php  */

define('SM_PATH','../../');

/* Calender plugin required files. */
require_once(SM_PATH . 'plugins/calendar/calendar_data.php');
require_once(SM_PATH . 'plugins/calendar/functions.php');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/html.php');

/* get globals */
$global_val_list = array( 'year', 'month' , 'day' ) ;
foreach($global_val_list as $global_val_name){
  if    (isset($_GET[$global_val_name]))  { $$global_val_name = $_GET[$global_val_name];  }
  elseif(isset($_POST[$global_val_name])) { $$global_val_name = $_POST[$global_val_name]; }
}
/* got 'em */

//  <!--  display upper part of Weekly view    -->
function startweek() {
  global $weekly_eventsG, $year, $month, $day, $sunday, $color;

    $week_str = array( _("Sunday"),   _("Monday"), _("Tuesday"), _("Wednesday"),
                       _("Thursday"), _("Friday"), _("Saturday") ) ;

    $self = 'week.php';
    $prev_date = mktime(0, 0, 0, $month, $day - 7 , $year);
    $act_date  = mktime(0, 0, 0, $month, $day     , $year);
    $next_date = mktime(0, 0, 0, $month, $day + 7 , $year);
    $prev_year=date('Y',$prev_date); $prev_month=date('m',$prev_date); $prev_day=date('d',$prev_date);
    $next_year=date('Y',$next_date); $next_month=date('m',$next_date); $next_day=date('d',$next_date);

  echo 
   html_tag( 'tr', '', '', $color[0] ) ."\n";
     html_tag( 'td', "\n" ) ;
     echo
       html_tag( 'table', '', '', $color[0], 'width="100%" border="0" cellpadding="2" cellspacing="1"' ) ;
       echo
         html_tag( 'tr', "\n" ) ;
         echo
           html_tag( 'th',
                     "<a href=\"$self?year=".($prev_year) . "&amp;month=".($prev_month) .
                               "&amp;day="  .($prev_day)  . "\">&lt;&lt;&nbsp;" . _("") ."</a>"
                     , 'left', $color[0], 'colspan="3"'
                   ) . "\n".
           html_tag( 'th', date_intl( _("Y ǯ W "), $act_date ) , '', $color[0], 'colspan="3"') .
           html_tag( 'th',
                     "<a href=\"$self?year=".($next_year)  . "&amp;month=".($next_month) .
                               "&amp;day="  .($next_day)   . "\">" . _("⽵") ."&nbsp;&gt;&gt;</a>"
                     , 'right', $color[0], 'colspan="3"'
                   ) . "\n" ;
       echo
         "</tr>\n" ;
       echo
         html_tag( 'tr', "\n" ) ;
         echo
           html_tag( 'th', "&nbsp;", '', $color[5], 'width="9%"' ) ."\n" ;
         for ($i=0;$i<7;++$i){
             $loop_year = date("Y",$sunday+(86400*$i)) ;
             $loop_month= date("m",$sunday+(86400*$i)) ;
             $loop_day  = date("d",$sunday+(86400*$i)) ;
             $cdate = $loop_month . $loop_day . $loop_year;
             $titleG = $weekly_eventsG['0700'][$i]['title'] ;
             $td_color = $color[5] ;
             if      ( $titleG!="" ) { $td_color = '#FFDBDC' ; $titleG ="<BR>".$titleG; }
             else if ( $i == 0)      { $td_color = '#FFDBDC' ; }
             else if ( $i == 6)      { $td_color = '#DFFFFF' ; }

           echo
             html_tag( 'th', 
                        "<a href=day.php?year=" . $loop_year .
                                  "&amp;month=" . $loop_month.
                                  "&amp;day="   . $loop_day  .  ">" .
                           '<FONT SIZE="-1">' .
                           $loop_month.'/'.$loop_day .'&nbsp;'. $week_str[$i] .
                           '</FONT><FONT SIZE="1" COLOR="#FF0000">' . $titleG .
                        '</FONT></a>'
                       , '', $td_color, 'VALIGN="top" width="13%"' ) ."\n" ;
         }
       echo
         "</tr>\n" ;
}

// <!--  main logic for Weekly view of calendar  -->
function drawweekview() {
  global $year, $month, $day, $sunday, $color;
  global $todayis, $weekly_events ;
  $ei = 1 ;
  foreach( $weekly_events as $time=>$fooevent ) {
    $ehh = substr($time,0,2); $emm = substr($time,2,2);
    if   ($emm!="00")  {  $ehhmm = '<FONT SIZE="-1">' .$emm. '</FONT>' ; }
    else               {  $ehhmm = $ehh.":".$emm ;                       }
    echo
      html_tag( 'tr','','', $color[(++$eo%2)*4]);
      echo '<td ALIGN="right">' . $ehhmm . '</td>' ;
      ++$ei ;
      for($w=0;$w<7;$w++){
        $lyear = date("Y",$sunday+(86400*$w)) ;
        $lmonth= date("m",$sunday+(86400*$w)) ;
        $lday  = date("d",$sunday+(86400*$w)) ;
        if (!is_array($fooevent[$w])){
          echo '<td ALIGN="right">' . "&nbsp;" .
               "<a href=\"event_create.php?year=" . $lyear  .
                                    "&amp;month=" . $lmonth .
                                    "&amp;day="   . $lday   .
                                    "&amp;hour="  . $ehh    .  "\">".
               '<FONT COLOR="' . $color[($ei%2)*4] . '">*</FONT></a>' .
          //   '<IMG SRC="add.png" ALT="٥ɲ"></a>' .
               '</td>' ;
        } else {
          $title_color = 1 ;
          if ($fooevent[$w]['priority'] == "1" ) $title_color = 6 ;
          echo '<td><FONT SIZE="1" COLOR="' . $color[$title_color]  . '">' .
               "<a href=\"event_edit.php?year="  . $lyear  .
                                  "&amp;month="  . $lmonth .
                                  "&amp;day="    . $lday   .
                                  "&amp;hour="   . $ehh    .
                                  "&amp;minute=" . $emm    .  "\">".
                $fooevent[$w]['title'] .
                '</FONT></td>' ;
        }
      }
    echo '</tr>' ;
  }

}

//  <!--  end of Weekly view and form to jump to any day,month and year  -->
function endweek() {
    global $year, $month, $day, $color;

    echo html_tag( 'tr' ) ."\n" .
           html_tag( 'td', '', 'left', $color[5], 'colspan="8"' ) ."\n" .
         "          <FORM NAME=caljump ACTION=\"week.php\" METHOD=POST>\n".
         "          <SELECT NAME=\"year\">\n";
                        select_option_year($year);
    echo "          </SELECT>ǯ\n".
         "          <SELECT NAME=\"month\">\n";
                        select_option_month($month);
    echo "          </SELECT>\n".
         "          <SELECT NAME=\"day\">\n";
                        select_option_day($day);
    echo "          </SELECT>\n".
         '         <INPUT TYPE=SUBMIT VALUE="' . _("Go") . "\">\n".
         "          </FORM>\n".
         "          </TD></TR>\n".
         "</TABLE></TD></TR></TABLE>\n";
}

// <!--  Get week events & event for specific week are inserted into "weekly" array  -->
function initialize_week_events() {
  global $weekly_eventsG, $weekly_events, $month, $day, $year, $sunday ;
  for ( $w=0;$w<7;$w++ ){
    for ($t=7;$t<23;$t++){
      if    ($t<10)  { $evntime = '0' . $t . '00' ; }
      else           { $evntime = $t . '00'       ; }
      $weekly_events[$evntime][$w] = 'empty';
    }
    $loop_year = date("Y",$sunday+(86400*$w)) ;
    $loop_month= date("m",$sunday+(86400*$w)) ;
    $loop_day  = date("d",$sunday+(86400*$w)) ;
    $cdate = $loop_month . $loop_day . $loop_year;

    $calendardata = readcalendardataday($loop_year, $loop_month, $loop_day) ;
    if (isset($calendardata[$cdate])){
      while ( $calfoo = each($calendardata[$cdate]) ){
        $weekly_events["$calfoo[key]"][$w] = $calendardata[$cdate][$calfoo['key']] ;
      }
    }
    ksort($weekly_events);
    $calendardataG = read_global_calendar_data_day($loop_year, $loop_month, $loop_day) ;
    if (isset($calendardataG[$cdate])){
      while ( $calfoo = each($calendardataG[$cdate]) ){
        $weekly_eventsG["$calfoo[key]"][$w] = $calendardataG[$cdate][$calfoo['key']] ;
      }
    }
  }
}
//  <!-------------------------------------------------------------------->

$weekly_events = array();
$weekly_eventsG = array();
if( !isset($month ) || $month <= 0){ $month = date( 'm' ); }
if( !isset($year)   || $year <= 0) { $year = date( 'Y' );  }
if( !isset($day)    || $day <= 0)  { $day = date( 'd' );   }

$todayis = date( 'mdY' );
$tmp_w = date("w", mktime(0, 0, 0, $month, $day, $year) ) ;
$sunday = mktime(0, 0, 0, $month, $day - $tmp_w,  $year);

$calself='week.php';   ///  $calself=basename($PHP_SELF);

displayPageHeader($color, 'None');
calendar_header();
initialize_week_events() ;
startweek()    ;
drawweekview() ;
endweek()      ;

//echo "<!--" ; print_r($weekly_events) ; echo "-->\n" ;
//echo "<!--" ; print_r($weekly_eventsG) ; echo "-->\n" ;

?>
</body></html>
