<?php

/** * event_create.php  */

define('SM_PATH','../../');

/* Calender plugin required files. */
require_once(SM_PATH . 'plugins/calendar/calendar_data.php');
require_once(SM_PATH . 'plugins/calendar/functions.php');
require_once(SM_PATH . 'plugins/calendar/event_create_event_form.php');
require_once(SM_PATH . 'plugins/calendar/event_create_confirm.php');
require_once(SM_PATH . 'plugins/calendar/event_create_save_result.php');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/html.php');

/* get globals */
unset($global_val_list) ;
$global_val_list = array('year', 'month', 'day', 'hour') ;
foreach($global_val_list as $global_val_name){
  if (isset($_GET[$global_val_name]))  {
     sqgetGlobalVar( $global_val_name, $$global_val_name , SQ_GET );
  } elseif (isset($_POST[$global_val_name])) {
     sqgetGlobalVar( $global_val_name, $$global_val_name , SQ_POST );
  }
//  if    (isset($_GET[$global_val_name]))  { $$global_val_name = $_GET[$global_val_name];  }
//  elseif(isset($_POST[$global_val_name])) { $$global_val_name = $_POST[$global_val_name]; }
}
unset($global_val_list) ;
$global_val_list =
  array( 'event_hour',     'event_minute', 'event_length', 'event_priority', 'event_title',    'event_text',
         'send',           'confirm',      'save',         'repeat',         'repeat_pattarn' ,
         'interval_day',   'interval_week', 'week_pttern',  'interval_months_month', 'interval_months_aday' ,
         'interval_months_week', 'interval_months_week_num' , 'interval_months_week_cnt' ,
         'end_year_repeats' ,    'end_month_repeats' ,        'end_day_repeats'
       ) ;
foreach($global_val_list as $global_val_name){
  if (isset($_POST[$global_val_name])) {
     sqgetGlobalVar( $global_val_name, $$global_val_name , SQ_POST );
  }
}
$event_title = htmlspecialchars( $event_title, ENT_QUOTES );
$event_text = htmlspecialchars( $event_text, ENT_QUOTES );

/* got 'em */

if ( !isset($month) || $month <= 0) { $month = date( 'm' ); }
if ( !isset($year)  || $year <= 0)  { $year  = date( 'Y' ); }
if ( !isset($day)   || $day <= 0)   { $day   = date( 'd' ); }
if ( !isset($hour)  || $hour <= 0)  { $hour  = '08';        }

$calself=basename($PHP_SELF);
displayPageHeader($color, 'None');

//  load calendar menu
calendar_header();

echo
  html_tag( 'tr', '', '', $color[0] ) . "\n"  .
    html_tag( 'td', '', 'left' ) . "\n"  .
      html_tag( 'table', '', '', $color[0], 'width="100%" border="0" cellpadding="2" cellspacing="1"' ) . "\n"  .
        html_tag( 'tr',
        html_tag( 'td', date_intl( _("l, F j Y"), mktime(0, 0, 0, $month, $day, $year)), 'left', '', 'colspan="2"' ) ."\n"
      );

//  if form has not been filled in
if(isset($send) && $send!="" ){		// 'send' bottn ->[CHECK REPEAT]->confirm
    confirm_event_form() ;
} else if(isset($confirm) && $confirm!="" && isset($_POST['Calendar_Data']) ){
    save_event() ;			// 'confirm' bottn -> save
} else {
    show_event_form();
}

?>
</table></td></tr></table>
</body></html>
