<?php
/**
 * event_delete.php
 */
define('SM_PATH','../../');

/* Calender plugin required files. */
require_once(SM_PATH . 'plugins/calendar/calendar_data.php');
require_once(SM_PATH . 'plugins/calendar/functions.php');
require_once(SM_PATH . 'plugins/calendar/event_delete_event_form.php');
require_once(SM_PATH . 'plugins/calendar/event_delete_confirm.php');
require_once(SM_PATH . 'plugins/calendar/event_delete_delete_result.php');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/date.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/html.php');

/* get globals */
unset($global_val_list) ;
$global_val_list =
  array('year',  'month',  'day',  'hour', 'dyear', 'dmonth', 'dday', 'dhour' , 'dminute' , 'dtitle' ,
        'repeat' , 'end_year_repeats' , 'end_month_repeats' , 'end_day_repeats' ) ;
foreach($global_val_list as $global_val_name){
  if    (isset($_GET[$global_val_name]))  { $$global_val_name = $_GET[$global_val_name];  }
  elseif(isset($_POST[$global_val_name])) { $$global_val_name = $_POST[$global_val_name]; }
}
if (isset($_POST['confirmed']))     { $confirmed     = $_POST['confirmed'];     }
if (isset($_POST['delete']))        { $delete        = $_POST['delete'];        }
/* got 'em */

$dtitle = htmlspecialchars( $dtitle, ENT_QUOTES );


if ($month <= 0) { $month = date( 'm' ); }
if ($year  <= 0) { $year  = date( 'Y' ); }
if ($day   <= 0) { $day   = date( 'd' ); }

$calself="event_delete.php";			//$calself=basename($PHP_SELF);

displayPageHeader($color, 'None');

//load calendar menu
calendar_header();
echo html_tag( 'tr', '', '', $color[0] ) .
           html_tag( 'td' ) .
               html_tag( 'table', '', '', $color[0], 'width="100%" border="0" cellpadding="2" cellspacing="1"' ) .
                   html_tag( 'tr' ) .
                       html_tag( 'td', '', 'left' ) .
     date_intl( _("l, F j Y"), mktime(0, 0, 0, $month, $day, $year));


if ( isset($dyear) && isset($dmonth) && isset($dday) && isset($dhour) && isset($dminute) ){
    if (isset($delete) && isset($_POST['Calendar_Data']) ) {		// 폜s
         delete_delete_result() ;
    } else if (isset($confirmed)  && isset($dtitle) ){			// 폜̃`FbNƊmF
        $stime = $dhour.$dminute ;
        if ( isset($repeat) && $repeat == "yes" ) {
          $calendardata = searchtitle( $dtitle , $dhour.$dminute , $end_year_repeats , $end_month_repeats ,$end_day_repeats ) ;
        } else {
          $calendardata = readcalendardataGetOne($dyear , $dmonth , $dday , "$dhour$dminute" ) ;
        }
        delete_confirm_event_form() ;
    } else {								// 폜ݒ肷
        $calendardata = readcalendardataGetOne($dyear , $dmonth , $dday , "$dhour$dminute" ) ;
        show_delete_event_form() ;
    }
} else {
    echo '<br>' . _("Nothing to delete!");
}
?>
</table></td></tr></table>
</body></html>
